unit UNetworkForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ExtCtrls, ComCtrls, StdCtrls, StdActns, ActnList;

  const                         {tbv graphics}
  PosX1=70;
  PosX2=PosX1+600;
  PosY1=70;
  PosY2=PosY1+300;
  LX = PosX2-PosX1;
  LY = PosY2-PosY1;

type
  TNetworkForm = class(TBaseForm)
    NetworkImage: TImage;
    SaveNetw_Button: TButton;
    MapSave_Dialog: TSaveDialog;
    SectionButton: TButton;
    Nodes_Button: TButton;

    procedure FormShow(Sender: TObject);
    procedure SaveNetw_ButtonClick(Sender: TObject);
    procedure MapSaveExecute(Sender: TObject);
    procedure Nodes_ButtonClick(Sender: TObject);
    procedure SectionButtonClick(Sender: TObject);

  private
    { Private declarations }

  MiniY, MiniX, MaxiY, MaxiX : integer;
  Yscale, Xscale : integer;
  Kilo, YesOk, NoMap         : boolean;
  DumReal                    : real;
  HlpStr, NameStr, AuxStr    : string;

  procedure MaxiMini;
  procedure TextFirstLine;
  procedure SetColorCode(CC:integer);
  procedure DefineNameStr(NN:integer);
  procedure DefineEndStr(NN:integer);

  public
    { Public declarations }
  Limit       : array[1..10] of real;
  ColorCode   : array[1..10] of integer;
  Decim       : integer;
  Yrel, Xrel  : real;

  procedure NetworkPicture;

  end;

var
  NetworkForm: TNetworkForm;

implementation

uses UMainForm, UDataMod, UExtraUtils, USelectPolyForm, USelectClassesForm;

{$R *.dfm}

procedure TNetworkForm.FormShow(Sender: TObject);
var Checked : boolean;
var ii:integer;
begin
  inherited;
  for ii:=1 to 6 do setlength(DataMod.NrOfSides,DataMod.NrOfIntPoly);
  setlength (DataMod.NodeNr,DataMod.TotNrOfPoly);
  if OutputOpened and not InputOpened then
  begin
    for ii:=0 to DataMod.TotNrOfPoly-1 do
        DataMod.NodeNr[ii]:=DataMod.NodalNr[ii];
    for ii:=0 to DataMod.NrOfIntPoly-1 do
        DataMod.NrOfSides[ii]:=DataMod.NrOfNeighbors[ii];
                 // NodeNr, NodalNr, NrOfSides, NrOfNeighbors te vereningen
  end;
  CheckNetworkData (Checked);
  if not Checked then
  begin
    showmessage ('Due to network errors the map may look distorted.'+
                 ' Depending on the degree of distortion, the program may'+
                 ' not function well.');
    exit;
  end;
  NetWorkForm.Height:=620;
  NetworkImage.Height:=530;
  YesOK:=true;
  SectionButton.Visible:=true;
  if DataMod.NrOfIntPoly<=20 then SectionButton.Visible:=false;
  NetworkPicture;
end;



procedure TNetworkForm.MaxiMini;
{------------------------------}

label 1;
var MarginX, MarginY : real;
    i : integer;

begin

1:Ymaxi := 0;
  Xmaxi := 0;
  Ymini := 10000000;
  Xmini := 10000000;

  with DataMod do
  begin

    for i:=0 to TotNrOfPoly-1 do
    begin
      if Ycoord[i]>Ymaxi then Ymaxi := Ycoord[i];
      if Ycoord[i]<Ymini then Ymini := Ycoord[i];
      if Xcoord[i]>Xmaxi then Xmaxi := Xcoord[i];
      if Xcoord[i]<Xmini then Xmini := Xcoord[i];
    end;
    Ymaxi:=Ymaxi+0.05*(Ymaxi-Ymini);
    Xmaxi:=Xmaxi+0.05*(Xmaxi-Xmini);
    Ymini:=Ymini-0.05*(Ymaxi-Ymini);
    Xmini:=Xmini-0.05*(Xmaxi-Xmini);

    Kilo := false;
    if Kilo=false then if ((Ymaxi>10000) or (Xmaxi>10000)) then
    begin
      Kilo:=true;
      for i:=1 to TotNrOfPoly do
      begin
        Xcoord[i]:=Xcoord[i]/1000;
        Ycoord[i]:=Ycoord[i]/1000;
      end;
      goto 1;
    end;

    MarginX := 0.1*Xmaxi;
    MarginY := 0.1*Ymaxi;

    if Ymaxi<10 then
    begin
      decim := 1;
      MiniY := round (Ymini-MarginX);
      MaxiY := round (Ymaxi+MarginY);
      Yscale := MaxiY-MiniY;
    end
    else if Ymaxi<100 then
    begin
      decim := 0;
      MiniY := round ((Ymini-MarginY));
      MaxiY := round ((Ymaxi+MarginY));
      Yscale := (MaxiY-MiniY) div 10;
    end
    else if Ymaxi<1000 then
    begin
      decim := 0;
      MiniY := 10*round ((Ymini-MarginY)/10);
      MaxiY := 10*round ((Ymaxi+MarginY)/10);
      Yscale := (MaxiY-MiniY) div 100;
    end
    else if Ymaxi<10000 then
    begin
      decim := 0;
      MiniY := 100*round ((Ymini-MarginY)/100);
      MaxiY := 100*round ((Ymaxi+MarginY)/100);
      Yscale := (MaxiY-MiniY) div 1000;
    end
    else if Ymaxi<100000 then
    begin
      decim := 0;
      MiniY := 1000*round ((Ymini-MarginY)/1000);
      MaxiY := 1000*round ((Ymaxi+MarginY)/1000);
      Yscale := (MaxiY-MiniY) div 10000;
    end
    else if Ymaxi<1000000 then
    begin
      decim := 0;
      MiniY := 10000*round ((Ymini-MarginY)/10000);
      MaxiY := 10000*round ((Ymaxi+MarginY)/10000);
      Yscale := (MaxiY-MiniY) div 100000;
    end;

    if Xmaxi<10 then
    begin
      decim := 1;
      MiniX := round (Xmini-MarginX);
      MaxiX := round (Xmaxi+MarginX);
      Xscale := MaxiX-MiniX;
    end
    else if Xmaxi<100 then
    begin
      decim := 0;
      MiniX := round(Xmini-MarginX);
      MaxiX := round(Xmaxi+MarginX);
      Xscale := (MaxiX-MiniX) div 10;
    end
    else if Xmaxi<1000 then
    begin
      decim := 0;
      MiniX := 10*round ((Xmini-MarginX)/10);
      MaxiX := 10*round ((Xmaxi+MarginX)/10);
      Xscale := (MaxiX-MiniX) div 100;
    end
    else if Xmaxi<10000 then
    begin
      decim := 0;
      MiniX := 100*round ((Xmini-MarginX)/100);
      MaxiX := 100*round ((Xmaxi+MarginX)/100);
      Xscale := (MaxiX-MiniX) div 1000;
    end
    else if Xmaxi<100000 then
    begin
      decim := 0;
      MiniX := 1000*round ((Xmini-MarginX)/1000);
      MaxiX := 1000*round ((Xmaxi+MarginX)/1000);
      Xscale := (MaxiX-MiniX) div 10000;
    end
    else if Xmaxi<1000000 then
    begin
      decim := 0;
      MiniX := 10000*round ((Xmini-MarginX)/10000);
      MaxiX := 10000*round ((Xmaxi+MarginX)/10000);
      Xscale := (MaxiX-MiniX) div 100000;
    end;

    if Yscale<3 then Yscale := 4;
    if Xscale<3 then Xscale := 4;

  end;  {with DataMod do}

end; {procedure TNetworkForm.MaxiMini;}
{-------------------------------------}



procedure TNetworkForm.NetworkPicture;
{------------------------------------}
label 1;
var i, ii, jj, Num           : integer;
    RelX, RelY               : integer;
    LegendX, LegendY         : string;
    PlotRelY, PlotRelX       : array[1..6] of real;
    RelPlotX, RelPlotY       : array[1..6] of integer;
begin

  MaxiMini;
  LegendX := 'X-coord. (cm)';
  LegendY := 'Y-coord. (cm)';
  if (Kilo) then
  begin
    LegendY := 'Y-coord.*1000';
    LegendX := 'X-coord.*1000';
  end;
  With NetworkImage.Canvas do with DataMod do
  begin
    Pen.Color := clWhite;
    Brush.Color := clWhite;
    FillRect(NetworkImage.Canvas.ClipRect);      {to clear the canvas}
    Font.Size:=10;
    Font.Style := [fsBold];
    Font.Color := clTeal;      {for the titles}
    Brush.Color := $00f5fffa;
    Font.Color := clMaroon;     {for the text}
    Pen.Color := clBlue;        {for the lines}
    TextOut (365,PosY2+26,LegendX);
    TextOut (PosX1-4,40,LegendY);
    NameStr:=inttostr(DataMod.Scale);
    NameStr:='NODAL NETWORK, Scale=1:'+Namestr;
    TextOut (275,25,NameStr);

// Y and X axes
    for ii:=0 to Yscale do                         { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/Yscale)*LY));
      Lineto (posX1-4, round(posY1+(ii/YScale)*LY));
      DumReal := ii/Yscale*(MaxiY-MiniY);
      NameStr := format('%' + IntToStr(2 + Decim) + '.' +
                 IntToStr(Decim) + 'f', [MaxiY - DumReal]);
          {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
         Textout ((posX1-TextWidth(NameStr)-6),
         (round(posY1+(ii/Yscale)*LY)-round(1/2*TextHeight(NameStr))),
                                                            NameStr);
    end; {for ii:=0 to ScalarY do}

    if MaxiX=MiniX then MiniX := 0;
    if (MaxiX<>MiniX) then                            { horizontal scale }
    for ii:=0 to Xscale do
    begin
      Moveto (round(posX1+(ii/Xscale)*LX),posY2);
      Lineto (round(posX1+(ii/Xscale)*LX),PosY2+4);
      Str (MiniX+ii/Xscale*(MaxiX-MiniX):2:Decim, DumStr);
      TextOut (round(posX1-8+(ii/Xscale)*LX),PosY2+12,DumStr);
    end else
    begin
      Moveto (posX1,320);
      Lineto (posX1,324);
      Str (Xmaxi:2:2,DumStr);
      TextOut (round(posX1-8),356,DumStr);
    end;

    moveto (PosX1,PosY2+4);                              {Axis lines}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    Font.Color := clBlack;                               {for the text}
    NameStr:=OpenFileName;

//The networkmap is not a color map
    if not ColorMap then
    if YesOK then                 {YesOK = show node numbers}
    begin
      if NameStr<>'' then
      begin
        NameStr:=extractfilename(NameStr);
        TextOut (70,PosY2+50,'SahysMod: ' + NameStr);
      end else
        TextOut (70,PosY2+50,'SahysMod: new network');
    end else
    begin
      if NameStr<>'' then
      begin
        NameStr:=extractfilename(NameStr);
        TextOut (45,PosY2+70,' SahysMod: ' + NameStr);
      end else
        TextOut (45,PosY2+70,' SahysMod: new network');
    end;

    if ColorMap then
    begin
      if NameStr<>'' then
      begin
        NameStr:=extractfilename(NameStr);
        TextOut (70,PosY2+45,'SahysMod: ' + NameStr);
      end else
        TextOut (70,PosY2+45,'SahysMod: new network');
    end;

    Font.Style:=[];
    if YesOK and not ColorMap then
    begin
      Font.Color := clMaroon;
      TextOut (70,PosY2+65,'* internal node');
      Font.Color:=clFuchsia;
      TextOut (190,PosY2+65,'* external node');
    end;
    setlength (RelXdata,6);
    Font.Name:='Tahoma';
    Font.Size:=10;
                                                      {plotting of nodal areas}
    for ii:=1 to 7 do setlength (SideNr[ii],NrOfIntPoly);
    for ii:=0 to NrOfIntPoly-1 do for jj:=1 to NrOfSides[ii] do
        SideNr[jj,ii]:=Neighbor[jj,ii];
//Re-arranging nodal relations to match the coordinates: internal nodes have
//been arranged 0..NrOfIntNodes-1 and external nodes NrOfIntNodes..TotNrOfNodes
//but their identification numbers may be different and adjustment is required
    Num:=TotNrOfPoly;
    for i:=0 to TotNrOfPoly-1 do
        if NodeNr[i]>Num then Num:=NodeNr[i];
    setlength (SeqNr,Num+1);
    jj:=-1;
    for i:=0 to TotNrOfPoly-1 do
    begin
     jj:=jj+1;
     SeqNr[NodeNr[i]]:=jj;
   end;

//Applicable to Topographic map
   if MainForm.Internal_RadioButton.Checked then
   if SelectClassesForm.Classes_ComboBox.ItemIndex=1 then
      ColNr:=1;
   if MainForm.Internal_RadioButton.Checked then
   if SelectClassesForm.Classes_ComboBox.ItemIndex=0 then
   begin
     ColNr:=1;
     DataMod.NrOfitems:=1;
     setlength (Variable[1],DataMod.NrOfIntPoly+1);
     setlength (TopLevel,DataMod.NrOfIntPoly+1);
     for jj:=0 to DataMod.NrOfIntPoly-1 do
     DataMod.Variable[1,jj]:=TopLevel[jj];
     PosValues[1]:=true;
     DataMod.NrOfData:=DataMod.NrOfIntPoly;
     if SelectClassesForm.Classes_ComboBox.ItemIndex=0 then
     begin
       MaxMin;
       Xrel:=Ymax[1];
       Yrel:=Ymin[1];
//       Xrel:=abs(Ymax[1]);
//       Yrel:=abs(Ymin[1]);
       Limit[1]:=Yrel+(Xrel-Yrel)/7;
       Limit[2]:=Yrel+2*(Xrel-Yrel)/7;
       Limit[3]:=Yrel+3*(Xrel-Yrel)/7;
       Limit[4]:=Yrel+4*(Xrel-Yrel)/7;
       Limit[5]:=Yrel+5*(Xrel-Yrel)/7;
       Limit[6]:=Yrel+6*(Xrel-Yrel)/7;
     end;
   end;

//{plotting of nodal numbers if not colormap, NETWORK map only}
    if YesOK and not ColorMap then
    begin
      NetWorkForm.Height:=560;
      Font.Size:=10;
      if NrOfIntPoly>100 then Font.Size:=6;
      if NrOfIntPoly>200 then with Canvas.Font do
      begin
        Name:='Terminal';
        Size:=6;
      end;
      for i:=1 to TotNrOfPoly do
      begin
        XRel := LX*(DataMod.Xcoord[i-1]-MiniX)/(MaxiX-MiniX);
        RelX := PosX1+round(XRel);
        YRel := LY*(DataMod.Ycoord[i-1]-MiniY)/(MaxiY-MiniY);
        RelY := PosY2-round(YRel);
        NameStr := IntToStr (NodeNr[i-1]);
        Font.Color:=clMaroon;
        if i>NrOfIntPoly then  Font.Color:=clFuchsia;
        if NrOfIntPoly>200 then
           TextOut (RelX-5,RelY-5,NameStr)
        else
           TextOut (RelX-5,RelY-9,NameStr);
      end;
    end; {if YesOK and not ColorMap then}

//Drawing polygons
   for i:=1 to NrOfIntPoly do
   begin
      Num:=i;
      GetCorners(Num);
      Num:=NrOfSides[i-1];
      if Num>2 then for ii:=1 to Num do
      begin
        PlotRelY[ii] := LY*(PointY[ii]-MiniY)/(MaxiY-MiniY);
        RelPlotY[ii] := PosY2-round(PlotRelY[ii]);
        PlotRelX[ii] := LX*(PointX[ii]-MiniX)/(MaxiX-MiniX);
        RelPlotX[ii] := PosX1+round(PlotRelX[ii]);
      end;

      if Num>2 then for ii:=1 to Num do     {plot polygons}
      begin
        if ii<Num then
        begin
          moveto(RelPlotX[ii],RelPlotY[ii]);
          lineto(RelPlotX[ii+1],RelPlotY[ii+1]);
        end;
        if ii=Num then
        begin
          moveto(RelPlotX[Num],RelPlotY[Num]);
          lineto(RelPlotX[1],RelPlotY[1]);
        end;
      end; {if Num>2 then}

    Font.Style:=[];
    if TotNrOfPoly>50 then Font.Size:=8;
    if TotNrOfPoly>100 then with Canvas.Font do
    begin
       Name:='Terminal';
       Size:=6;
    end;

      if ColorMap then   {plotting colored polygons}
      begin
        for ii:=1 to Num do
        begin
          PlotRelY[1] := LY*(PointY[ii]-MiniY)/(MaxiY-MiniY);
          RelPlotY[2] := PosY2-round(PlotRelY[ii]);
          PlotRelX[1] := LX*(PointX[ii]-MiniX)/(MaxiX-MiniX);
          RelPlotX[2] := PosX1+round(PlotRelX[ii]);
        end; {for ii:=1 to Num do}

        if MainForm.DepthWT_RadioButton.Checked then ColNr:=1;
//        if MainForm.AvSal_RadioButton.Checked then ColNr:=3;
        if MainForm.SaltSto_RadioButton.Checked then ColNr:=5;
        if MainForm.Evapo_RadioButton.Checked then ColNr:=7;
        if not MainForm.Internal_RadioButton.Checked then
           DumReal:=DataMod.Variable[ColNr,i-1]
        else
           DumReal:=DataMod.TopLevel[i-1];

        if MainForm.Internal_RadioButton.Checked then
        DumReal:=DataMod.TopLevel[i-1];

        if not MainForm.GroundWater_RadioButton.Checked then
        if DumReal<0 then
           begin
           Brush.Color:=clWhite;
           goto 1;
        end;

//Filling polygon colors for standard topgraphic map
       if (SelectClassesForm.Classes_ComboBox.ItemIndex=0) then
       begin
         if (DumReal>Limit[6]) then Brush.Color:=clYellow;
         if (DumReal<=Limit[6]) and (DumReal>Limit[5]) then
             Brush.Color:=$004080FF;
         if (DumReal<=Limit[5]) and (DumReal>Limit[4]) then
             Brush.Color:=$00BFD6F7;
         if (DumReal<=Limit[4]) and (DumReal>Limit[3]) then
             Brush.Color:=$0035AC13;
         if (DumReal<=Limit[3]) and (DumReal>Limit[2]) then
             Brush.Color:=$0080ff80;
         if (DumReal<=Limit[2]) and (DumReal>Limit[1]) then
             Brush.Color:=clAqua;
         if (DumReal<=Limit[1]) then Brush.Color:=$00E4925A;
         if not MainForm.GroundWater_RadioButton.Checked then
         if (DumReal<=0) then Brush.Color:=clWhite;
       end;

//Filling the polygon colors for map with slected limits and colors
       if (SelectClassesForm.Classes_ComboBox.ItemIndex=1) then
       BEGIN
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>5 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=6 then
                if (DumReal>Limit[9]) then
                begin
                  Brush.Color:=clOlive;
                  Limit[10]:=Limit[9]
                end;
           end;
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>4 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=5 then
                if (DumReal>Limit[8]) then
                begin
                  Brush.Color:=clOlive;
                  Limit[9]:=Limit[8]
                end;
           end;
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>3 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=4 then
                if (DumReal>Limit[7]) then
                begin
                  Brush.Color:=clOlive;
                  Limit[8]:=Limit[7]
                end;
           end;
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>2 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=3 then
                if (DumReal>Limit[6]) then
                begin
                  Brush.Color:=clOlive;
                  Limit[7]:=Limit[6]
                end;
           end;
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>1 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=2 then
                if (DumReal>Limit[5]) then
                begin
                  Brush.Color:=clOlive;
                  Limit[6]:=Limit[5]
                end;
           end;
           if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>0 then
           begin
             if SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=1 then
                if (DumReal>Limit[4]) then
               begin
                  Brush.Color:=clOlive;
                  Limit[5]:=Limit[4]
                end;
             if (DumReal<=Limit[9]) and (DumReal>Limit[8]) then
                SetColorCode (9);
             if (DumReal<=Limit[8]) and (DumReal>Limit[7]) then
                SetColorCode (8);
             if (DumReal<=Limit[7]) and (DumReal>Limit[6]) then
                SetColorCode (7);
             if (DumReal<=Limit[6]) and (DumReal>Limit[5]) then
                SetColorCode (6);
             if (DumReal<=Limit[5]) and (DumReal>Limit[4]) then
                SetColorCode (5);
             if (DumReal<=Limit[4]) and (DumReal>Limit[3]) then
                SetColorCode (4);
             if (DumReal<=Limit[3]) and (DumReal>Limit[2]) then
                SetColorCode (3);
             if (DumReal<=Limit[2]) and (DumReal>Limit[1]) then
                SetColorCode (2);
             if (DumReal<=Limit[1]) then
                SetColorCode (1);
           end;
       END;

// Polygons are depicted as colored squares
1:     Fillrect (Rect(RelPlotX[1],RelPlotY[1],RelPlotX[3],RelPlotY[3]));

       Font.Color := clMaroon;     {for the text}
//show polygon numbers
            Font.Size:=10;
            if NrOfIntPoly>100 then Font.Size:=6;
            if NrOfIntPoly>200 then with Canvas.Font do
            begin
              Name:='Terminal';
              Size:=6;
            end;

           if YesOK then        {node numbers + brush if colormap}
           begin
              Font.Color:=clBlack;
              XRel := LX*(DataMod.Xcoord[i-1]-MiniX)/(MaxiX-MiniX);
              RelX := PosX1+round(XRel);
              YRel := LY*(DataMod.Ycoord[i-1]-MiniY)/(MaxiY-MiniY);
              RelY := PosY2-round(YRel);
              NameStr := IntToStr (NodeNr[i-1]);
              if NrOfIntPoly>200 then
                 TextOut (RelX-5,RelY-5,NameStr)
              else
                 TextOut (RelX-5,RelY-9,NameStr);
            end;

            Font.Size:=10;
            Font.Name:='Tahoma';

//The boundaries of the polygons are drawn
            Pen.Color := clMaroon;        {for the lines}
            if Num>2 then for ii:=1 to Num do     {plot polygons}
            begin
              if ii<Num then
              begin
                moveto(RelPlotX[ii],RelPlotY[ii]);
                lineto(RelPlotX[ii+1],RelPlotY[ii+1]);
              end;
              if ii=Num then
              begin
                moveto(RelPlotX[Num],RelPlotY[Num]);
                lineto(RelPlotX[1],RelPlotY[1]);
              end;
            end; {if Num>2 then}

      end; {if ColorMap then}
  end; {for i:=1 to NrOfIntPoly do}
//end of drawing polygons

//writing explanation above classes blocks
          if ColorMap then
          begin
            Brush.Color:=clWhite;
            TextFirstLine;
            Brush.Color:=clWhite;
            TextOut (70,PosY2+75,NameStr);

//Writing class limits within the blocks for Colormap, for first three blocks
//ColNr is the column number selected from data in a group with USelectColumnForm
           if MainForm.DepthWT_RadioButton.Checked then ColNr:=1;
//           if MainForm.AvSal_RadioButton.Checked then ColNr:=3;
//1st block
              if SelectClassesForm.Classes_ComboBox.ItemIndex=1 then
                 SetColorCode (1)
              else Brush.Color:=$00E4925A;
              if Ymax[DataMod.ColNr]<1.001 then
                 NameStr:=' <= ' + format('%4.2f',[Limit[1]]) + '  '
              else
              if (Ymax[DataMod.ColNr]>10) and (Ymax[DataMod.ColNr]<100) then
                 NameStr:=' <= ' + format('%4.1f',[Limit[1]]) + '  '
              else
                 NameStr:=' <= ' + format('%4.0f',[Limit[1]]) + '  ';
              TextOut (90,PosY2+95,NameStr);
//2nd block
              if SelectClassesForm.Classes_ComboBox.ItemIndex=1 then
                 SetColorCode (2)
              else Brush.Color:=clAqua;
              DefineNameStr(2);
              TextOut (180,PosY2+95,NameStr);
//3rd block
              if SelectClassesForm.Classes_ComboBox.ItemIndex=1 then
                 SetColorCode (3)
              else Brush.Color:=$0080ff80;
              DefineNameStr(3);
              TextOut (270,PosY2+95,NameStr);
//3rd block last if ItemIndex=0
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=0) then
              begin
                DefineEndStr(3);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex=0) then
                   Brush.Color:=clYellow
                else Brush.Color:=clOlive;
                TextOut (360,PosY2+95,NameStr);
              end;
//Writing class limits within the blocks for Colormap, block nrs. > 3
//4th block
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>0 THEN
              BEGIN
                DefineNameStr(4);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (4)
                else Brush.Color:=$0035AC13;
                TextOut (360,PosY2+95,NameStr);
              END;
//4th block last if ItemIndex=1
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=1) then
              begin
                DefineEndStr(4);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   Brush.Color:=clYellow
                else Brush.Color:=clOlive;
                TextOut (450,PosY2+95,NameStr);
              end;
//5th block
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>1 THEN
              BEGIN
                DefineNameStr(5);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (5)
                else Brush.Color:=$00BFD6F7;
                TextOut (450,PosY2+95,NameStr);
              END;
//5th block last if ItemIndex=2
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=2) then
              begin
                DefineEndStr(5);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex=0) then
                   Brush.Color:=clYellow
                else Brush.Color:=clOlive;
                TextOut (540,PosY2+95,NameStr);
              end;
//6th block
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>2 THEN
              BEGIN
                DefineNameStr(6);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (6)
                else Brush.Color:=$004080FF;
                TextOut (540,PosY2+95,NameStr);
              END;
//6th block last if ItemIndex=3
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=3) then
              begin
                DefineEndStr(6);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   Brush.Color:=clOlive
                else Brush.Color:=clYellow;
                TextOut (630,PosY2+95,NameStr);
              end;
//7th block
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>3 THEN
              BEGIN
                DefineNameStr(7);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (7)
                else Brush.Color:=$0039BCF9;
                TextOut (90,PosY2+115,NameStr);
              END;
//7th block last if ItemIndex=4
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=4) then
              begin
                DefineEndStr(7);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   Brush.Color:=clOlive
                else Brush.Color:=clYellow;
                TextOut (180,PosY2+115,NameStr);
              end;
//8th block
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex>4 THEN
              BEGIN
                DefineNameStr(8);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (8)
                else Brush.Color:=$0068CCBE;
                TextOut (180,PosY2+115,NameStr);
              END;
//8th block last if ItemIndex=5
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=5) then
              begin
                DefineEndStr(8);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   Brush.Color:=clOlive
                else Brush.Color:=clYellow;
                TextOut (270,PosY2+115,NameStr);
              end;
//9th block LAST
              IF SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=6 THEN
              BEGIN
                DefineNameStr(9);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   SetColorCode (9)
                else Brush.Color:=$00E9B1BE;
                TextOut (270,PosY2+115,NameStr);
              END;
//9th block last if ItemIndex=6
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex=6) then
              begin
                DefineEndStr(9);
                if (SelectClassesForm.Classes_ComboBox.ItemIndex>0) then
                   Brush.Color:=clOlive
                else Brush.Color:=clYellow;
                TextOut (360,PosY2+115,NameStr);
              end;
//End of writing class limits within the blocks for Colormap

//Write line below blocks
              Brush.Color:=clwhite;
              if (SelectClassesForm.Classes_ComboBox.ItemIndex=0) then
                  NameStr:= ' White color: no data of this kind present';
              if (SelectClassesForm.Classes_ComboBox.ItemIndex=1) then
                  NameStr:= ' White color: no data present'+
                            ' in the classes defined.';
              if (SelectClassesForm.NrOfClasses_ComboBox.ItemIndex<4) then
                 TextOut (70,PosY2+115,NameStr)
              else
                 TextOut (70,PosY2+135,NameStr);

        end; {if ColorMap then}

  end; {With NetworkImage.Canvas do with DataMod do}
end; {TNetworkForm.NetworkPicture}
{--------------------------------}


procedure TNetWorkForm.TextFirstLine;
{------------------------------------}
begin
  with DataMod do
  begin
            Brush.Color:=clwhite;
            if MainForm.SoilSal_RadioButton.Checked then
            begin
              NameStr:=inttostr(YearWanted);
              HlpStr:=inttostr(SeasonWanted);
              NoMap:=false;
              if ColNr=1 then
              begin
                AuxStr:='CrA (land under A-type crops)';
                if not DataPresent[1] then NoMap:=true;
              end;
              if ColNr=2 then
              begin
                AuxStr:='CrB (land under B-type crops)';
                if not DataPresent[2] then NoMap:=true;
              end;
              if ColNr=3 then
              begin
                AuxStr:='CrU (unirrigated land)';
                if not DataPresent[3] then NoMap:=true;
              end;
              if ColNr=4 then
              begin
                AuxStr:='Cr4 (full crop rotation)';
                if not DataPresent[4] then NoMap:=true;
              end;
              if ColNr=5 then
              begin
                AuxStr:='C0* (land with crop rotation)';
                if not DataPresent[5] then NoMap:=true;
              end;
              if ColNr=6 then
              begin
                AuxStr:='C1* (land with crop rotation)';
                if not DataPresent[6] then NoMap:=true;
              end;
              if ColNr=7 then
              begin
                AuxStr:='C2* (land with crop rotation)';
                if not DataPresent[7] then NoMap:=true;
              end;
              if ColNr=8 then
              begin
                AuxStr:='C3* (land with crop rotaion)';
                if not DataPresent[8] then NoMap:=true;
              end;
              if NoMap then
                 NameStr:= ' In group '+AuxStr+' no data are present.'+
                           ' Hence no map colors shown.              '
              else
                 NameStr:= 'Classification of soil salinity '+AuxStr+
                           ' in dS/m for month '+NameStr+
                           '                             ';
            end;  {if MainForm.SoilSal_RadioButton.Checked then}
(*
            if MainForm.AvSal_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NameStr:= 'Classification of weighted average salinity'+
                         ' in dS/m m for year '+NameStr+' season '+HlpStr+
                            '                    ';
            end;
*)
            if MainForm.DepthWT_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NameStr:= 'Classification of watertable depth'+
                         ' in m for month '+NameStr+
                            '                          ';
            end;

            if MainForm.SubSal_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='Cxf (transition zone)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='Cxa (transition zone above drain level)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='Cxb (transition zone below drain level)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Cqf (aquifer)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= 'Classification of subsoil salinity '+AuxStr+
                            ' in dS/m for month '+NameStr+
                            '                           ';
            end; {if MainForm.SubSal_RadioButton.Checked then}

            if MainForm.OtherSal_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='Cti (incoming groundwater transition zone)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='Cqi (incoming groundwater aquifer)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='Ci (irrigation water)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Cd (drainage water) ';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if ColNr=5 then
               begin
                 AuxStr:='Cw (well water)';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= 'Classification of salinity '+AuxStr+
                            ' in dS/m for month '+NameStr+
                            '                           ';
            end;  {if MainForm.OtherSal_RadioButton.Checked then}

            if MainForm.SaltSto_RadioButton.Checked then
            begin
    //           NameStr:= 'Classification of salt at soil surface'+
    //                    ' in dS/m for year '+NameStr+' season '+HlpStr;
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
    //           NameStr:= 'Classification of salt at soil surface'+
    //                    ' in dS/m for year '+NameStr+' season '+HlpStr;
               NoMap:=false;
               if ColNr=5 then
               begin
                 AuxStr:= 'Zs';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= 'Classification of salt storage at surfcae '+AuxStr+
                            ' in m.dS/m for month '+NameStr+
                            '                             ';
            end;  {if MainForm.SaltSto_RadioButton.Checked then}

            if MainForm.Groundwater_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='Gti (incoming groundwater transition zone)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='Gto (outgoing groundwater transition zone)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='Gtv (upward seepage transition zone)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Gqi (incoming aquifer)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if ColNr=5 then
               begin
                 AuxStr:='Gqo (outgoing aquifer)';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if ColNr=6 then
               begin
                 AuxStr:='Gaq (upward seepage from aquifer)';
                 if not DataPresent[6] then NoMap:=true;
               end;
               if ColNr=7 then
               begin
                 AuxStr:='Gnt (net flow)';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Groundwater flow classes '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.Groundwater_RadioButton.Checked then}


            if MainForm.Discharge_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='Gd (total)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='Ga (from above drain level)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='Gb from above drain level)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Gw (rom wells)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Drain and well discharge classes '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.Discharge_RadioButton.Checked then}

            if MainForm.Percol_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='LrA (from land with A-type crops)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='LrB (from land with B-type crops)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='LrU (from unirrigated land)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Lr (total)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Percolation classes for '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.Percol_RadioButton.Checked then}

            if MainForm.Capil_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='RrA (into root zone of A-type crops)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='RrB (into root zone of B-type crops)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='RrU (into unirrigated land)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Rr (total into root zone)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Capillary rise classes for '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.Capil_RadioButton.Checked then}

            if MainForm.CanalIrr_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='It (irrigation)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='Is (to the fields)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='IaA (lands with A-type crops)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='IaB (lands with B-type crops)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if ColNr=5 then
               begin
                 AuxStr:='Io (bypass)';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Irrigation classes for '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.CanalIrr_RadioButton.Checked then}

            if MainForm.IrrEff_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='Ffa (irrigation efficiency of A-type crops)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='FfB (irrigation efficiency of A-type crops)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='Fft (overall irrigation efficiency)';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='JsA (irrigation sufficiency of A-type crops)';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if ColNr=5 then
               begin
                 AuxStr:='JsB (irrigation sufficiency of B-type crops)';
                 if not DataPresent[5] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Classes for '+AuxStr+
                            ' for month '+NameStr+
                            '                           ';
            end;  {if MainForm.IrrEff_RadioButton.Checked then}

            if MainForm.Evapo_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               AuxStr:= 'EaU (from unirrigated land)';
               if not DataPresent[7] then NoMap:=true;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= 'Classification of net evaporation '+AuxStr+
                            ' in m/month for month '+NameStr+
                            '                           ';
            end;  {if MainForm.Evapo_RadioButton.Checked then}

            if MainForm.CropArea_RadioButton.Checked then
            begin
               NameStr:=inttostr(YearWanted);
               HlpStr:=inttostr(SeasonWanted);
               NoMap:=false;
               if ColNr=1 then
               begin
                 AuxStr:='A land (under group A crops)';
                 if not DataPresent[1] then NoMap:=true;
               end;
               if ColNr=2 then
               begin
                 AuxStr:='B land (under group B crops)';
                 if not DataPresent[2] then NoMap:=true;
               end;
               if ColNr=3 then
               begin
                 AuxStr:='U (seasonally unirrigated) land';
                 if not DataPresent[3] then NoMap:=true;
               end;
               if ColNr=4 then
               begin
                 AuxStr:='Uc (permanently unirrigated) land';
                 if not DataPresent[4] then NoMap:=true;
               end;
               if NoMap then
                  NameStr:= ' In group '+AuxStr+' no data are present.'+
                            ' Hence no map colors shown.              '
               else
                  NameStr:= ' Crop area fractions of '+AuxStr+
                            ' for oeriod '+NameStr+
                            '                           ';
            end;  {if MainForm.CropArea_RadioButton.Checked then}

            if MainForm.Internal_RadioButton.Checked then
            begin
              NameStr:= ' Topographic surface level classes in m.'+
                        '                                        ';
            end;
  end; {with DataMod do}
end; {TextFirstLine}
{-------------------}



procedure TNetWorkForm.SetColorCode(CC:integer);
{----------------------------------------------}
begin
 with NetworkImage.Canvas do
 begin
  if ColorCode[CC]=1 then Brush.Color:=$0046A741
  else if ColorCode[CC]=2 then Brush.Color:=$008BDA9B
  else if ColorCode[CC]=3 then Brush.Color:=$006AFCFF
  else if ColorCode[CC]=4 then Brush.Color:=$0000A5FF
  else if ColorCode[CC]=5 then Brush.Color:=clRed
  else if ColorCode[CC]=6 then Brush.Color:=clFuchsia
  else if ColorCode[CC]=7 then Brush.Color:=$00F0A968
  else if ColorCode[CC]=8 then Brush.Color:=$00FDF599
  else if ColorCode[CC]=9 then Brush.Color:=clSilver
  else if ColorCode[CC]=10 then Brush.Color:=$006286D2
  else if ColorCode[CC]=11 then Brush.Color:=$0039BCF9
  else if ColorCode[CC]=12 then Brush.Color:=$0068CCBE
  else if ColorCode[CC]=13 then Brush.Color:=$00E4B1BE
  else if ColorCode[CC]=14 then Brush.Color:=$0098C09D;
 end;
end; {SetColorCode}
{-----------------}


procedure TNetworkForm.DefineNameStr(NN:integer);
{-----------------------------------------------}
begin
  if (Ymean[DataMod.ColNr]<1) then
  begin
    HlpStr:=format('%4.2f',[Limit[NN-1]]);
    NameStr:=HlpStr + ' -' + format('%4.2f',[Limit[NN]])+'  '
  end else
  if (Ymean[DataMod.ColNr]<10) then
  begin
    HlpStr:=format('%4.1f',[Limit[NN-1]]);
    NameStr:=HlpStr + ' -' + format('%4.1f',[Limit[NN]])+'  '
  end else
  begin
    HlpStr:=format('%4.0f',[Limit[NN-1]]);
    NameStr:=HlpStr + ' -' + format('%4.0f',[Limit[NN]])+'  ';
  end;
end; {DefineNameStr}
{------------------}


procedure TNetworkForm.DefineEndStr(NN:integer);
{----------------------------------------------}
begin
  if Ymean[DataMod.ColNr]<1 then
     NameStr:=' > ' + format('%4.2f',[Limit[NN]]) + '  '
  else
  if (Ymean[DataMod.ColNr]<10) then
     NameStr:=' > ' + format('%4.1f',[Limit[NN]]) + '  '
  else
     NameStr:=' > ' + format('%4.0f',[Limit[NN]]) + '  ';
end; {DefineEndStr}
{-----------------}



procedure TNetworkForm.SaveNetw_ButtonClick(Sender: TObject);
{-----------------------------------------------------------}
begin
  inherited;
  MapSaveExecute (Sender);
end; {TNetworkForm.SaveNetw_ButtonClick}
{--------------------------------------}


procedure TNetworkForm.MapSaveExecute(Sender: TObject);
var Result : boolean;
    MapName : string;
begin
  inherited;
      if MapSave_Dialog.Execute then with DataMod do
      begin MapName := MapSave_Dialog.Files.Strings[0];
        if FileExists(MapName) then
             Result := Question('The map file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          NetworkImage.Picture.SaveToFile(MapName);
          Showmessage ('The network map was saved in  ' + MapName);
        end;
      end
      else Showmessage ('The network map was not saved');

end;


procedure TNetworkForm.Nodes_ButtonClick(Sender: TObject);
begin
  inherited;
  if Nodes_Button.Caption= 'Remove node numbers' then
  begin
    YesOK:=false;
    Nodes_Button.Caption := 'Show node numbers';
  end else
  begin
    YesOK:=true;
    Nodes_Button.Caption := 'Remove node numbers';
  end;
  NetWorkPicture;
end;


procedure TNetworkForm.SectionButtonClick(Sender: TObject);
begin
  inherited;
  SelectPolyForm.Show;
end;


end.

